VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "XTimer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'=================================================
' ACHTUNG! Klicken Sie NICHT auf auf die Beenden-
'   Schaltflche, whrend Sie dieses Projekt aus-
'   fhren! Weitere Informationen finden Sie am
'   Anfang des Moduls XTimerSupport (XTimerS.bas).
'=================================================

' Private Speicher fr XTimer-Eigenschaften:
Private mlngTimerID As Long
Private mlngInterval As Long
Private mblnEnabled As Boolean
Private mTag
' Das einzige XTimer-Ereignis ist Tick. Das Tick-Ereignis
'   von XTimer besitzt keine Argumente (dadurch wird die
'   Ausfhrung etwas beschleunigt), aber es gibt keinen
'   prinzipiellen Grund, keine Argumente zu verwenden.
Event Timer()

' TimerID (Eigenschaft)
' -------
'   ist erforderlich fr die EndTimer-Prozedur, damit
'   der Zeitgeber schnell im Datenfeld der aktiven
'   Zeitgeber gefunden werden kann (definiert im Modul
'   XTimerSupport).
'
' Es gibt keinen Grund, diese Eigenschaft im Client zu
'   verwenden. Daher ist sie als Friend und nicht als
'   Public deklariert.
'
Friend Property Get TimerID() As Long
    TimerID = mlngTimerID
End Property

Public Property Get Tag() As Variant
  Tag = mTag
End Property

Public Property Let Tag(nTag As Variant)
  mTag = nTag
End Property


' Enabled (Eigenschaft)
' -------
'   aktiviert und deaktiviert Zeitgeber. Dazu werden
'   aktive Systemzeitgeber immer gelscht, da es keine
'   Mglichkeit gibt, sie anzuhalten. Nach ihrer
'   Erstellung laufen sie immer weiter.
'
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_UserMemId = 0
    Enabled = mblnEnabled
End Property

Public Property Let Enabled(ByVal NewValue As Boolean)
    ' Falls sich die Eigenschaft nicht ndert, wird die
    '   Prozedur verlassen. Diese verhindert, da ein
    '   weiterer Systemzeitgeber gestartet wird, obwohl
    '   bereits einer vorhanden ist.
    If NewValue = mblnEnabled Then Exit Property
    '
    ' Speichern der neuen Einstellung.
    mblnEnabled = NewValue
    '
    ' Falls das Intervall Null ist, wurde der Zeitgeber
    '   bereits angehalten. Er kann nicht wieder
    '   gestartet werden.
    If mlngInterval = 0 Then Exit Property
    '
    ' Zeitgeber aktivieren bzw. deaktivieren.
    If mblnEnabled Then
        Debug.Assert mlngTimerID = 0
        mlngTimerID = BeginTimer(Me, mlngInterval)
    Else
        ' Die folgende Unterscheidung ist erforderlich,
        '   da ein XTimer-Objekt den zugehrigen System-
        '   zeitgeber auf zwei Weisen deaktivieren kann:
        '   Enabled = False oder Interval = 0.
        If mlngTimerID <> 0 Then
            Call EndTimer(Me)
            mlngTimerID = 0
        End If
    End If
End Property

Public Property Get Interval() As Long
    Interval = mlngInterval
End Property
'
Public Property Let Interval(ByVal NewInterval As Long)
    ' Falls das neue Intervall mit dem alten identisch
    '   ist, wird die Prozedur einfach verlassen.
    If NewInterval = mlngInterval Then Exit Property
    '
    ' Speichern des neuen Wertes.
    mlngInterval = NewInterval
    '
    ' Falls das XTimer-Objekt aktiv ist, enthlt
    '   mlngTimerID einen Wert ungleich Null. In diesem
    '   Fall mu der alte Systemzeitgeber beendet und
    '   ein neuer gestartet werden.
    If mlngTimerID <> 0 Then
        Call EndTimer(Me)
        mlngTimerID = 0
    End If
    '
    ' Falls das neue Intervall Null ist, wird das XTimer-
    '   Objekt unabhngig vom Wert der Enabled-Eigenschaft
    '   deaktiviert. Falls das neue Intervall ungleich Null
    '   UND die Enabled-Eigenschaft True ist, wir ein neuer
    '   Systemzeitgeber gestartet und die ID in mlngTimerID
    '   gespeichert.
    If (NewInterval <> 0) And mblnEnabled Then
        mlngTimerID = BeginTimer(Me, NewInterval)
    End If
End Property

Public Sub RaiseTick()
    RaiseEvent Timer
End Sub

Private Sub Class_Terminate()
    ' Wenn der Client seinen letzten Verweis auf ein
    '   XTimer-Objekt freigibt, wird es zerstrt - aber
    '   nur, wenn die Enabled-Eigenschaft False oder
    '   die Intervall-Eigenschaft Null ist!
    '
    ' Dies hat folgenden Grund: Whrend der Systemzeit-
    '   geber des XTimer-Objekts luft, mu im Modul
    '   XTimerSupport ein Verweis auf das XTimer-Objekt
    '   bestehen, um das Tick-Ereignis auszulsen.
    '   Daher werden Systemzeitgeber blockiert, wenn
    '   ein Client XTimer-Objekte freigibt, ohne sie
    '   vorher zu deaktivieren.
    '
    ' Diese blockierten Systemzeitgeber werden nicht
    '   freigegeben, bis die XTimers-Komponente beendet
    '   wird - d.h. bis der Client beendet wird, der
    '   die DLL verwendet. Die DLL wird NICHT aus dem
    '   Speicher entfernt, wenn nur alle XTimer-Verweise
    '   freigegeben werden, da Verweise auf ffentliche
    '   Objekte (in diesem Fall durch XTimerSupport) das
    '   Entladen der DLL verhindern.
    '
    ' Warum sollten Sie die Systemzeitgeber im
    '   Terminate-Ereignis freigeben? Beim Entladen der
    '   DLL werden alle Verweise auf XTimer-Objekte
    '   gelscht - und die Terminate-Ereignisse der
    '   Objekte werden ausgelst. Zu diesem Zeitpunkt
    '   sollten auch die Systemzeitgeber freigegeben
    '   werden.
    On Error Resume Next
    If mlngTimerID <> 0 Then KillTimer 0, mlngTimerID
    '
    ' Folgender Befehl sollte vom XTimer-Objekt ausgefhrt
    '   werden, falls es irgendwie vor dem Entladen der
    '   DLL freigegeben wird.
    'If mlngTimerID <> 0 Then Call EndTimer(Me)
End Sub

